/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdFillrectRop.cpp
// ****************************************************************
*/
#include "CDcdFillrectRop.h"
#include "CConverter_WinGdi.h"

namespace DcDrawLib{
namespace DcDraw{

// ****************************************************************
//	CDcdFillrectRop
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CDcdFillrectRop::CDcdFillrectRop( 
	const CdBrushProp& aCdBrushProp , 
	int iR2DrawMode) 
	: m_CdBrushProp( aCdBrushProp ) 
	, m_iR2DrawMode( iR2DrawMode ) 
{
}
CDcdFillrectRop::CDcdFillrectRop() 
	: m_iR2DrawMode( R2_COPYPEN ) 
{
}
CDcdFillrectRop::~CDcdFillrectRop() 
{
}

const CdPenProp	g_CdPenProp( 1 , CdColorProp() , CdPenProp::NULLPEN ) ;

// ********************************
//	IfDcDraw
// ********************************
bool CDcdFillrectRop::DcDraw( IfDcdTarget* pIfDcdTarget ) 
{
	int		iRv = 0 ;
	bool	bRv = false ;
	

	// --------------------------------
	//	ROP̐ݒ
	// --------------------------------
	int iRopSid = SetROP2( pIfDcdTarget->getHdc() , m_iR2DrawMode ) ;

	// --------------------------------
	//	yEuV̐
	// --------------------------------
	Ou<CGdiHPenHolder>	pHPenHolder ;
	if ( iRv >= 0 ){
		pHPenHolder = pIfDcdTarget->createGdiHPenHolder( g_CdPenProp ) ;
		if ( pHPenHolder == NULL ){
			iRv = -1 ;	//	y̍쐬Ɏs܂B
		}
	}
	Ou<CGdiHBrushHolder>	pHBrushHolder ;
	if ( iRv >= 0 ){
		pHBrushHolder = pIfDcdTarget->createGdiHBrushHolder( m_CdBrushProp ) ;
		if ( pHBrushHolder == NULL ){
			iRv = -2 ;	//	uV̍쐬Ɏs܂B
		}
	}
	HBRUSH		hBrushSid = NULL ;
	if ( iRv >= 0 ){
		hBrushSid = (HBRUSH)SelectObject( pIfDcdTarget->getHdc() , pHBrushHolder->getHBrush() ) ;
	}
	HPEN		hPenSid = NULL ;
	if ( iRv >= 0 ){
		hPenSid = (HPEN)SelectObject( pIfDcdTarget->getHdc() , pHPenHolder->getHPen() ) ;
	}
	int iBkModeSid = -1 ;
	if ( iRv >= 0 ){
		 iBkModeSid = SetBkMode( pIfDcdTarget->getHdc() , TRANSPARENT ) ;
	}
	// --------------------------------
	//	`
	// --------------------------------
	if ( iRv >= 0 ){
		CdDcdZoneXy	aCdDcdZoneXy = pIfDcdTarget->getZone() ;
		RECT	LRect ;
		LRect.left   = aCdDcdZoneXy.getX().getPos() ;
		LRect.top    = aCdDcdZoneXy.getY().getPos() ;
		LRect.right  = aCdDcdZoneXy.getX().getEndPos() ;
		LRect.bottom = aCdDcdZoneXy.getY().getEndPos() ;
		
		Rectangle( pIfDcdTarget->getHdc() , 
			LRect.left , LRect.top , LRect.right + 1 , LRect.bottom + 1 ) ;
		
	}
	if ( iRv >= 0 ){
		bRv = true ;
	}
	// --------------------------------
	if ( iBkModeSid != -1 ) {
		SetBkMode( pIfDcdTarget->getHdc() , iBkModeSid ) ;
	}
	if ( hBrushSid != NULL ){
		SelectObject( pIfDcdTarget->getHdc() , hBrushSid ) ;
		hBrushSid = NULL ;
	}
	if ( hPenSid != NULL ){
		SelectObject( pIfDcdTarget->getHdc() , hPenSid ) ;
		hPenSid = NULL ;
	}
	if ( iRopSid != 0 )
	{
		 SetROP2( pIfDcdTarget->getHdc() , iRopSid ) ;
		 iRopSid = 0 ;
	}
	return ( bRv ) ;
}
	
bool CDcdFillrectRop::getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) 
{
	return ( false ) ;
}

} //namespace DcDraw
} //namespace DcDrawLib

