/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CWndDcdGrid.cpp : Cve[V t@C
//

#include "DcdGrid\WndDcdGrid3\CWndDcdGrid.h"
#include "DcdGrid\WndDcdGrid3\CPropStack.h"
#include "NsOu/OuNew.h"
#include "DcDraw/CDcdTargetGetDC.h"
#include "DcDraw/CDcdTargetOnPaint.h"
#include "DcDraw/CaDcdTargetItemPosition.h"
#include "DcDraw/CDcdRectangle.h"
#include "LogMsg/LogMsg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace DcDrawLib{
namespace DcdGrid{
namespace WndDcdGrid3{


/////////////////////////////////////////////////////////////////////////////
// CWndDcdGrid

///	üOhbOXN[ṽ^C}ID
const UINT_PTR OutsideDrag_TIMERID = 1 ;

// --------------------------------
//@name	֐
// --------------------------------
bool CWndDcdGrid::update() 
{
	bool bRv = false ;
	if ( GetSafeHwnd() != NULL )
	{

		if ( !m_bDisable_UpdateAll )
		{
			//LogMsg( "CWndDcdGrid::update()" ) ;

			m_bDisable_UpdateAll = true ;
			// --------------------------------
			bRv |= m_pCDcdGrid->update_adjustProp() ;
			bRv |= m_pCFocus->update_adjustProp() ;
			bRv |= m_pCSelect->update_adjustProp() ;

			bRv |= m_pCBoxSelect->update_adjustProp() ;
			bRv |= m_pCRandomSelect->update_adjustProp() ;
			if ( bRv )
			{
				//	CBoxSelect,CRandomSelect ́A CSelectXV܂B
				//	̍XVɑ΂鐳KsKv邽߁A
				//	ēx CSelet::update_adjustProp() sĂ܂B
				bRv |= m_pCSelect->update_adjustProp() ;
				bRv |= m_pCFocus->update_adjustProp() ;
				bRv |= m_pCDcdGrid->update_adjustProp() ;
			}

			// --------------------------------
			bRv |= m_pCDcdGrid->update_updateScreen() ;
			bRv |= m_pCFocus->update_updateScreen() ;
			bRv |= m_pCSelect->update_updateScreen() ;
			bRv |= m_pCBoxSelect->update_updateScreen() ;
			bRv |= m_pCRandomSelect->update_updateScreen() ;
			// --------------------------------
			m_bDisable_UpdateAll = false ;

			//LogMsg( "CWndDcdGrid::update()=%d" , bRv ) ;
		}
	}
	return ( bRv ) ;
}

Ou<CPropStack>  CWndDcdGrid::createPropStackForMovingFocusCell()
{
	OuNew<CPropStack> pPropStack( new CPropStack( this ) ) ;
	pPropStack->CFocus_setFixafterColumnNumberChange( true ) ;
	return pPropStack ;

}
Ou<CPropStack> CWndDcdGrid::createPropStackForScroll() 
{
	OuNew<CPropStack> pPropStack( new CPropStack( this ) ) ;
	pPropStack->CFocus_setFixafterColumnNumberChange( false ) ;
	return pPropStack ;
}

// ********************************
//	RXgN^
// ********************************
CWndDcdGrid::CWndDcdGrid()
	: m_iOutsideDrag_TimeMs( 100 )
	, m_bOutsideDrag_TimerOn( false ) 
	, m_bDisable_UpdateAll( false ) 
	, m_bLButtonIsDown( false ) 
{
	m_pCDcdGrid = new CXDcdGrid( this ) ;

	m_pCFocus = new CFocus( this ) ;

	m_pCSelect = new CSelect( this ) ;

	m_pCBoxSelect = new CBoxSelect( this ) ;

	m_pCRandomSelect = new CRandomSelect( this ) ;

}

CWndDcdGrid::~CWndDcdGrid()
{
	delete m_pCRandomSelect ; m_pCRandomSelect = NULL ;
	delete m_pCBoxSelect ;m_pCBoxSelect = NULL ;
	delete m_pCSelect ;	m_pCSelect = NULL ;
	delete m_pCFocus ;	m_pCFocus = NULL ;
	delete m_pCDcdGrid ;m_pCDcdGrid = NULL ;
}

// ********************************
//	CDcdGrid
// ********************************
	// --------------------------------
	//@name sEEZ̏
	// --------------------------------
void CWndDcdGrid::OnCreateXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) 
{
	m_pCDcdGrid->CDcdGrid::OnCreateXColumn( iXColumnNumber , 
		pCDcdGridXColumn ) ;

	//	CSelect ɈϏ
	m_pCSelect->OnCreateXColumn( iXColumnNumber ) ;
}
	
void CWndDcdGrid::OnDeleteXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) 
{
	m_pCDcdGrid->CDcdGrid::OnDeleteXColumn( iXColumnNumber , 
		pCDcdGridXColumn ) ;

	//	CSelect ɈϏ
	m_pCSelect->OnDeleteXColumn( iXColumnNumber ) ;
}

void CWndDcdGrid::OnCreateYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) 
{
	m_pCDcdGrid->CDcdGrid::OnCreateYColumn( iYColumnNumber , 
		pCDcdGridYColumn ) ;

	//	CSelect ɈϏ
	m_pCSelect->OnCreateYColumn( iYColumnNumber ) ;
}

void CWndDcdGrid::OnDeleteYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) 
{
	m_pCDcdGrid->CDcdGrid::OnDeleteYColumn( iYColumnNumber , 
		pCDcdGridYColumn ) ;

	//	CSelect ɈϏ
	m_pCSelect->OnDeleteYColumn( iYColumnNumber ) ;
}

void CWndDcdGrid::OnCreateCell( int iXColumnNumber , int iYColumnNumber , 
		CDcdGridCell* pCDcdGridCell ) 
{
	m_pCDcdGrid->CDcdGrid::OnCreateCell( 
		iXColumnNumber , iYColumnNumber , 
		pCDcdGridCell ) ;
}
	
void CWndDcdGrid::OnDeleteCell( int iXColumnNumber , int iYColumnNumber , 
		CDcdGridCell* pCDcdGridCell ) 
{
	m_pCDcdGrid->CDcdGrid::OnDeleteCell( 
		iXColumnNumber , iYColumnNumber , 
		pCDcdGridCell ) ;
}

	// ********************************
	//	@name YEẌʒu
	// ********************************
CdDcdZone	CWndDcdGrid::getYColumnZone( 
			int iYColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getYColumnZone( 
			&aCDcdTarget , iYColumnNumber ) ;
};
		
CdDcdZone	CWndDcdGrid::getXColumnZone( 
			int iXColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getXColumnZone( 
			&aCDcdTarget  , iXColumnNumber ) ;
};
	
CdDcdZone	CWndDcdGrid::getYColumnBorderZone( 
			int iYColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getYColumnBorderZone( 
			&aCDcdTarget  , iYColumnNumber ) ;
};

CdDcdZone	CWndDcdGrid::getXColumnBorderZone( 
			int iXColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getXColumnBorderZone( 
			 &aCDcdTarget  , iXColumnNumber ) ;
};

CdDcdZoneXy	CWndDcdGrid::getCellZone( 
		int iXColumnNumber , int iYColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getCellZone( 
			&aCDcdTarget  , iXColumnNumber , iYColumnNumber ) ;
};
	

int CWndDcdGrid::getYColumnNumberOfPos( 
		int iPos , bool* pbIsBorder ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getYColumnNumberOfPos( 
			&aCDcdTarget  , iPos , pbIsBorder ) ;
};

int CWndDcdGrid::getXColumnNumberOfPos( 
		int iPos , bool* pbIsBorder ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getXColumnNumberOfPos( 
			&aCDcdTarget  , iPos , pbIsBorder ) ;
};


CDcdGridCell* CWndDcdGrid::getCellOfPos( 
		const CdDcdPosXy& aCdDcdPosXy ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getCellOfPos( 
			&aCDcdTarget  , aCdDcdPosXy ) ;
};

CdDcdSizeXy CWndDcdGrid::calcIncreaseOnOutsideDrag( const POINT& pos ) 
{
	CdDcdSizeXy	sizeFixafterColumnNumberIncrease ;

	CRect	rectClient ;
	GetClientRect( &rectClient ) ; 

	//	tH[JXZ̗ԍ
	CdDcdPosXy	posFocusCellColumnNumber = getCFocus()->getFocusCellColumnNumber() ;

	//	X
	if ( m_pCDcdGrid->getXFixColumnCount() <= posFocusCellColumnNumber.getX() &&
		posFocusCellColumnNumber.getX() < m_pCDcdGrid->getXColumnCount() )
	{
		//	tH[JXZAXN[\ɂ

		//	[ւ̃XN[\(FixColumnCount < FixafterColumnNumber)
		//	AND }EXJ[\XWAFixColumn荶 ]
		//	^C}ł̉EXN[
		if ( m_pCDcdGrid->getXFixColumnCount() < m_pCDcdGrid->getXFixafterColumnNumber() )	//	ւ̃XN[\
		{
			int iScrollColumnStartPos = rectClient.left ;
			if ( m_pCDcdGrid->getXFixColumnCount() > 0 )
			{
				CdDcdZone	aZone = getXColumnBorderZone( m_pCDcdGrid->getXFixColumnCount() - 1 ) ;
				if ( iScrollColumnStartPos < aZone.getEndPos() )
				{
					iScrollColumnStartPos = aZone.getEndPos() ;
				}
			}
			//	iScrollColumnStartPos = XN[\̍XW
			if ( pos.x < iScrollColumnStartPos )
			{
				//	ւ́üOhbOXN[vKvȏ
				sizeFixafterColumnNumberIncrease.setX( -1 );
			}
		}
		//	[Eւ̃XN[\( FixafterColumnNumber < ColumnCount - 1 )
		//	AND }EXJ[\XWAGridE܂̓EChẼNCAgWE ]
		//	^C}ł̍XN[
		if ( m_pCDcdGrid->getXFixafterColumnNumber() < m_pCDcdGrid->getXColumnCount() - 1 )	//	Eւ̃XN[\
		{
			int iScrollColumnEndPos = rectClient.right ;
			{
				CdDcdZone	aZone = getXColumnBorderZone( m_pCDcdGrid->getXColumnCount() - 1 ) ;
				if ( iScrollColumnEndPos > aZone.getPos() ) 
				{
					iScrollColumnEndPos = aZone.getPos() ;
				}
			}
			if ( iScrollColumnEndPos < pos.x )
			{
				//	Eւ́üOhbOXN[vKvȏ
				sizeFixafterColumnNumberIncrease.setX( +1 );
			}
		}
	}

	//	Y
	if ( m_pCDcdGrid->getYFixColumnCount() <= posFocusCellColumnNumber.getY() &&
		posFocusCellColumnNumber.getY() < m_pCDcdGrid->getYColumnCount() )
	{
		//	tH[JXZAXN[\ɂ

		//	[ւ̃XN[\(FixColumnCount < FixafterColumnNumber)
		//	AND }EXJ[\YWAFixColumn ]
		//	^C}ł̉EXN[
		if ( m_pCDcdGrid->getYFixColumnCount() < m_pCDcdGrid->getYFixafterColumnNumber() )	//	ւ̃XN[\
		{
			int iScrollColumnStartPos = rectClient.top ;
			if ( m_pCDcdGrid->getYFixColumnCount() > 0 )
			{
				CdDcdZone	aZone = getYColumnBorderZone( m_pCDcdGrid->getYFixColumnCount() - 1 ) ;
				if ( iScrollColumnStartPos < aZone.getEndPos() )
				{
					iScrollColumnStartPos = aZone.getEndPos() ;
				}
			}
			//	iScrollColumnStartPos = XN[\̏㑤YW
			if ( pos.y < iScrollColumnStartPos )
			{
				//	ւ́üOhbOXN[vKvȏ
				sizeFixafterColumnNumberIncrease.setY( -1 );
			}
		}
		//	[Eւ̃XN[\( FixafterColumnNumber < ColumnCount - 1 )
		//	AND }EXJ[\YWAColumn艺A܂̓EChE艺 ]
		//	^C}ł̍XN[
		if ( m_pCDcdGrid->getYFixafterColumnNumber() < m_pCDcdGrid->getYColumnCount() - 1 )	//	Eւ̃XN[\
		{
			int iScrollColumnEndPos = rectClient.bottom ;
			{
				CdDcdZone	aZone = getYColumnBorderZone( m_pCDcdGrid->getYColumnCount() - 1 ) ;
				if ( iScrollColumnEndPos > aZone.getPos() ) 
				{
					iScrollColumnEndPos = aZone.getPos() ;
				}
			}
			//	iScrollColumnStartPos = XN[\̏㑤YW
			if ( iScrollColumnEndPos < pos.y )
			{
				//	ւ́üOhbOXN[vKvȏ
				sizeFixafterColumnNumberIncrease.setY( +1 );
			}
		}
	}

	return sizeFixafterColumnNumberIncrease ;
}
	// ********************************
	//	@name	Ž
	// ********************************
CdDcdZone	CWndDcdGrid::getYColumnZoneOverlap( 
			int iYColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getYColumnZoneOverlap( 
			&aCDcdTarget  , iYColumnNumber ) ;
}
CdDcdZone	CWndDcdGrid::getXColumnZoneOverlap( 
			int iXColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getXColumnZoneOverlap( 
			&aCDcdTarget  , iXColumnNumber ) ;
}

CdDcdZoneXy	CWndDcdGrid::getCellZoneOverlap( 
		int iXColumnNumber , int iYColumnNumber ) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	return m_pCDcdGrid->getCellZoneOverlap( 
		&aCDcdTarget  , iXColumnNumber , iYColumnNumber ) ;
}
// ********************************
//	@name	
// ********************************

// ********************************
//	CWndDcdGrid
// ********************************
	// --------------------------------
	//@name	Cxĝ߂̉z֐
	// --------------------------------
void CWndDcdGrid::OnSetFocusCell( CDcdGridCell* pcdcdgridcell ) 
{
	if ( pcdcdgridcell!= NULL ){
		LogMsg(_T("onsetfocuscell( x=%d y=%d )") ,
			m_pCDcdGrid->getXColumnNumberOfCell( pcdcdgridcell ) ,
			m_pCDcdGrid->getYColumnNumberOfCell( pcdcdgridcell ) ) ;
	}	else	{
		LogMsg(_T("onsetfocuscell( null )") ) ;
	}
}
void CWndDcdGrid::OnSetXFixafterColumnNumber( int iFixafterColumnNumber ) 
{
	LogMsg(_T("CWndDcdGrid::OnSetXFixafterColumnNumber(%d)") ,
		iFixafterColumnNumber ) ;
}
void CWndDcdGrid::OnSetYFixafterColumnNumber( int iFixafterColumnNumber ) 
{
	LogMsg(_T("CWndDcdGrid::OnSetYFixafterColumnNumber(%d)") ,
		iFixafterColumnNumber ) ;
}

void CWndDcdGrid::OnChangeSelectCell( 
		int iXColumnNumber , int iYColumnNumber , bool bIsSelected )
{
	//LogMsg( _T("CWndDcdGrid::OnChangeSelectCell(%d,%d,%d)") , 
	//	iXColumnNumber , iYColumnNumber , bIsSelected ) ;
}

	// ********************************
	//@name ֘A
	// ********************************

	// ********************************
	//@name 
	// ********************************
CXDcdGrid*	CWndDcdGrid::getCXDcdGrid() 
{
	return m_pCDcdGrid ;
}
CFocus*	CWndDcdGrid::getCFocus() 
{
	return m_pCFocus ;
}

CSelect*	CWndDcdGrid::getCSelect() 
{
	return m_pCSelect ;
}

CBoxSelect*	CWndDcdGrid::getCBoxSelect() 
{
	return m_pCBoxSelect ;
}
CRandomSelect*	CWndDcdGrid::getCRandomSelect() 
{
	return m_pCRandomSelect ;
}

	// ********************************
	//@name	\z
	// ********************************
BOOL CWndDcdGrid::Create( 
	const RECT& rect, CWnd* pParentWnd, UINT nID )
{
	return CreateEx( 0 
		, AfxRegisterWndClass( CS_DBLCLKS //| CS_HREDRAW | CS_VREDRAW 
			, LoadCursor( NULL , IDC_ARROW ) 
			, (HBRUSH)GetStockObject( WHITE_BRUSH ) 
			, NULL ) 
		, _T("CWndDcdGrid")	//	̕񂪕\邱Ƃ͂܂
		, WS_CHILD | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP
		, rect
		, pParentWnd
		, nID
		, NULL ) ;
}

BOOL CWndDcdGrid::Create( CWnd* pParentWnd, UINT nID )
{
	return CreateEx( 0 
		, AfxRegisterWndClass( CS_DBLCLKS //| CS_HREDRAW | CS_VREDRAW 
			, LoadCursor( NULL , IDC_ARROW ) 
			, (HBRUSH)GetStockObject( WHITE_BRUSH ) 
			, NULL ) 
		, _T("CWndDcdGrid")	//	̕񂪕\邱Ƃ͂܂
		, WS_CHILD | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP
		, CRect( 0 , 0 , 0 , 0 ) 
		, pParentWnd
		, nID
		, NULL ) ;
}

	// ********************************
	//@name CWndDcdGrid-
	// ********************************

bool CWndDcdGrid::isShiftPressed()
{
	SHORT	iVal = GetKeyState( VK_SHIFT ) ;
	return ( ( iVal & 0x8000 ) != 0 ) ;
}
bool CWndDcdGrid::isCtrlPressed()
{
	SHORT	iVal = GetKeyState( VK_CONTROL ) ;
	return ( ( iVal & 0x8000 ) != 0 ) ;
}

void CWndDcdGrid::selectAll() 
{
	m_pCBoxSelect->clearSelect() ;
	m_pCSelect->selectAll() ;
}


void CWndDcdGrid::clearSelect() 
{
	m_pCBoxSelect->clearSelect() ;
	m_pCSelect->clearSelect() ;
}

	// ********************************
	//@name CWndDcdGrid-EChEXV
	// ********************************
int  CWndDcdGrid::InvalidateXColumnBorder( int iXColumnNumber , 
	bool bErase ) 
{
	int iRv = 0 ;

	// --------------------------------
	//	ĕ`̈߂
	// --------------------------------
	CRect	rectClient ;
	CdDcdZone	zoneClient ;
	if ( iRv >= 0 ){
		GetClientRect( &rectClient ) ;
		zoneClient.setPos( rectClient.left ).setSize( rectClient.right - rectClient.left ) ;
	}
	//rectClient = NCAg̈̋`
	//zoneClient = NCAg̈̕

	CdDcdZone	zoneInvalidate ;
	if ( iRv >= 0 ){
		CdDcdZone	zoneBorder = getXColumnBorderZone( iXColumnNumber ) ;
		zoneInvalidate = zoneBorder.CrossZone( zoneClient ) ;
	}
	//zoneInvalidate = NCAg̈撆ŁAË
	
	// --------------------------------
	//	ĕ`
	// --------------------------------
	if ( iRv >= 0 ){
		if ( zoneInvalidate.getSize() > 0 ){
			CRect	rectInvalidate = rectClient ;
			rectInvalidate.left = zoneInvalidate.getPos() ;
			rectInvalidate.right = zoneInvalidate.getEndPos() ;
			InvalidateRect( rectInvalidate , bErase ) ;
			iRv = 1 ;
		}
	}	
	

	return ( iRv ) ;
	
}

int CWndDcdGrid::InvalidateYColumnBorder( int iYColumnNumber ,
	bool bErase ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	ĕ`̈߂
	// --------------------------------
	CRect	rectClient ;
	CdDcdZone	zoneClient ;
	if ( iRv >= 0 ){
		GetClientRect( &rectClient ) ;
		zoneClient.setPos( rectClient.top ).setSize( rectClient.bottom - rectClient.top ) ;
	}
	//rectClient = NCAg̈̋`
	//zoneClient = NCAg̈̕

	CdDcdZone	zoneInvalidate ;
	if ( iRv >= 0 ){
		CdDcdZone	zoneBorder = getYColumnBorderZone( iYColumnNumber ) ;
		zoneInvalidate = zoneBorder.CrossZone( zoneClient ) ;
	}
	//zoneInvalidate = NCAg̈撆ŁAË
	
	// --------------------------------
	//	ĕ`
	// --------------------------------
	if ( iRv >= 0 ){
		if ( zoneInvalidate.getSize() > 0 ){
			CRect	rectInvalidate = rectClient ;
			rectInvalidate.top = zoneInvalidate.getPos() ;
			rectInvalidate.bottom = zoneInvalidate.getEndPos() ;
			InvalidateRect( rectInvalidate , bErase ) ;
			iRv = 1 ;
		}
	}	
	

	return ( iRv ) ;
}

int CWndDcdGrid::InvalidateCell( int iXColumnNumber , int iYColumnNumber , 
	bool bErase ) 
{
	int iRv = 0 ;
	// --------------------------------
	//	ĕ`̈߂
	// --------------------------------
	CRect	rectClient ;
	CdDcdZoneXy	zoneClient ;
	if ( iRv >= 0 ){
		GetClientRect( &rectClient ) ;
		zoneClient.setX( CdDcdZone( rectClient.left , rectClient.right - rectClient.left ) )
			.setY( CdDcdZone( rectClient.top , rectClient.bottom - rectClient.top ) ) ;
	}
	//rectClient = NCAg̈̋`
	//zoneClient = NCAg̈̕

	CdDcdZoneXy	zoneInvalidate ;
	if ( iRv >= 0 ){
		CdDcdZoneXy	zoneCell = getCellZone( iXColumnNumber , iYColumnNumber ) ;
		zoneInvalidate = zoneCell.CrossZone( zoneClient ) ;
	}
	//zoneInvalidate = NCAg̈撆ŁAË
	
	// --------------------------------
	//	ĕ`
	// --------------------------------
	if ( iRv >= 0 ){
		if ( zoneInvalidate.getX().getSize() > 0 && 
				zoneInvalidate.getY().getSize() > 0 ){
			CRect	rectInvalidate = rectClient ;
			rectInvalidate.left = zoneInvalidate.getX().getPos() ;
			rectInvalidate.right = zoneInvalidate.getX().getEndPos() ;
			rectInvalidate.top = zoneInvalidate.getY().getPos() ;
			rectInvalidate.bottom = zoneInvalidate.getY().getEndPos() ;
			InvalidateRect( rectInvalidate , bErase ) ;
			iRv = 1 ;
		}
	}	
	
	return ( iRv ) ;
}

 void CWndDcdGrid::InvalidateGrid( 
		bool bErase )
{
	m_pCDcdGrid->InvalidateGrid( bErase ) ;
	m_pCFocus->InvalidateGrid() ;
	m_pCSelect->InvalidateGrid() ;
	m_pCBoxSelect->InvalidateGrid() ;
	m_pCRandomSelect->InvalidateGrid() ;
	
	super::Invalidate( bErase ) ;

	//	Ŝ̑XV
	update() ;
 }

// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CWndDcdGrid, CWnd)
	//{{AFX_MSG_MAP(CWndDcdGrid)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndDcdGrid bZ[W nh

void CWndDcdGrid::OnPaint() 
{
	// --------------------------------
	//	`
	// --------------------------------
	{
		CPaintDC dc(this); // `p̃foCX ReLXg
		
		CDcdTargetOnPaint	aCDcdTarget( GetSafeHwnd() , &dc.m_ps ) ;
		
		{
			CdDcdZoneXy	aDrawableZone = aCDcdTarget.getDrawableZone() ;
			//LogMsgL( 3 , "CWndDcdGrid::OnPaint() x=%d,%d y=%d,%d" ,
			//	aDrawableZone.getX().getPos() , 
			//	aDrawableZone.getX().getSize() , 
			//	aDrawableZone.getY().getPos() , 
			//	aDrawableZone.getY().getSize() ) ;
		}
		// --------------------------------	
		//	Grid
		// --------------------------------	
		m_pCDcdGrid->DcDraw( &aCDcdTarget );
		
		// --------------------------------	
		//	tH[JX}[N
		// --------------------------------	
		m_pCFocus->OnPaint(  &aCDcdTarget ) ;

		// --------------------------------	
		//	I}[N
		// --------------------------------	
		m_pCSelect->OnPaint(  &aCDcdTarget ) ;


		// --------------------------------	
		//	BoxSelect
		// --------------------------------	
		m_pCBoxSelect->OnPaint(  &aCDcdTarget ) ;
		
		// --------------------------------	
		//	RandomSelect
		// --------------------------------	
		m_pCRandomSelect->OnPaint(  &aCDcdTarget ) ;


	}
}


void CWndDcdGrid::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	
	SCROLLINFO	aSCROLLINFO ;
	memset ( &aSCROLLINFO , 0 , sizeof(aSCROLLINFO) ) ;
	aSCROLLINFO.cbSize = sizeof(aSCROLLINFO) ;
	aSCROLLINFO.fMask = SIF_ALL ;
	GetScrollInfo( SB_HORZ , &aSCROLLINFO , SIF_ALL ) ;
	
	if ( pScrollBar == NULL )
	{
		switch( nSBCode )
		{
		 case SB_LINELEFT:
			{
				{
					//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setXFixafterColumnNumber( m_pCDcdGrid->getXFixafterColumnNumber() - 1 ) ;
				}
			}
			break ; 
		 case SB_LINERIGHT:
			{
				{
					//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setXFixafterColumnNumber( m_pCDcdGrid->getXFixafterColumnNumber() + 1 ) ;
				}
			}
			break ; 
		 case SB_PAGELEFT:
			{
				int iFixafterColumnNumber = m_pCDcdGrid->getXFixafterColumnNumber() ;
				int iFixafterColumnNumberNew = m_pCDcdGrid->
					calcXFixafterColumnNumberPagemove( &aCDcdTarget , 
						iFixafterColumnNumber , false ) ;

				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setXFixafterColumnNumber( iFixafterColumnNumberNew ) ;
				}
			}
			break ;
		 case SB_PAGERIGHT:
			{
				int iFixafterColumnNumber = m_pCDcdGrid->getXFixafterColumnNumber() ;
				int iFixafterColumnNumberNew = m_pCDcdGrid->
					calcXFixafterColumnNumberPagemove( &aCDcdTarget , 
						iFixafterColumnNumber , true ) ;

				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setXFixafterColumnNumber( iFixafterColumnNumberNew ) ;
				}
			}
			break ;
		 case SB_THUMBPOSITION :
			{
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setXFixafterColumnNumber( nPos ) ;
				}
			}
			break ;
		 case SB_THUMBTRACK :
			{
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setXFixafterColumnNumber( nPos ) ;
				}
			}
			break ;
		 case SB_ENDSCROLL:
			{
			}
			break ;
		}
	}
	else
	{
		super::OnHScroll(nSBCode, nPos, pScrollBar);
	}
}	

void CWndDcdGrid::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;
	
	SCROLLINFO	aSCROLLINFO ;
	memset ( &aSCROLLINFO , 0 , sizeof(aSCROLLINFO) ) ;
	aSCROLLINFO.cbSize = sizeof(aSCROLLINFO) ;
	aSCROLLINFO.fMask = SIF_ALL ;
	GetScrollInfo( SB_VERT , &aSCROLLINFO , SIF_ALL ) ;
	
	if ( pScrollBar == NULL )
	{
		switch( nSBCode )
		{
		 case SB_LINEUP:
			{
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setYFixafterColumnNumber( m_pCDcdGrid->getYFixafterColumnNumber() - 1 ) ;
				}
			}
			break ; 
		 case SB_LINEDOWN:
			{
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setYFixafterColumnNumber( m_pCDcdGrid->getYFixafterColumnNumber() + 1 ) ;
				}
			}
			break ; 
		 case SB_PAGEUP:
			{
				int iFixafterColumnNumber = m_pCDcdGrid->getYFixafterColumnNumber() ;
				int iFixafterColumnNumberNew = m_pCDcdGrid->
					calcYFixafterColumnNumberPagemove( &aCDcdTarget , 
						iFixafterColumnNumber , false ) ;
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setYFixafterColumnNumber( iFixafterColumnNumberNew ) ;
				}
			}
			break ;
		 case SB_PAGEDOWN:
			{
				int iFixafterColumnNumber = m_pCDcdGrid->getYFixafterColumnNumber() ;
				int iFixafterColumnNumberNew = m_pCDcdGrid->
					calcYFixafterColumnNumberPagemove( &aCDcdTarget , 
						iFixafterColumnNumber , true ) ;
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setYFixafterColumnNumber( iFixafterColumnNumberNew ) ;
				}
			}
			break ;
		 case SB_THUMBPOSITION :
			{
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setYFixafterColumnNumber( nPos ) ;
				}
			}
			break ;
		 case SB_THUMBTRACK :
			{
				//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
				{
					Ou<CPropStack> pPropStack = createPropStackForScroll() ;

					m_pCDcdGrid->setYFixafterColumnNumber( nPos ) ;
				}
			}
			break ;
		 case SB_ENDSCROLL:
			{
			}
			break ;
		}
	}
	else
	{
		super::OnVScroll(nSBCode, nPos, pScrollBar);
	}
	
}

void CWndDcdGrid::OnSize(UINT nType, int cx, int cy) 
{
	
	if ( cx == 0 || cy == 0 )
	{
		//	̂Q̂̂ꂩ0̏ꍇA
		//	Create() ŃTCYw肹ɃEChE
		//	̂Ǝv܂B
		//	̏ꍇ́A[U[ɂ͉Ȃ킯łA
		//	tH[JXZ̈ʒu̍œKȂǂ͂Ȃ
		//	Kv܂B
		//
		//	܂Ȃ傫̂Ƃ adjustProp() 
		//	sƁAtH[JXʒu͖ (0,0) 
		//	ړĂ܂܂B̂߁A
		//	adjustProp() ͂Ȃ
		//	悢ł傤B
		return ;
	}
	super::OnSize(nType, cx, cy);

	//	WCX^XɈϏ
	m_pCFocus->OnSize( nType, cx, cy) ;
	m_pCSelect->OnSize( nType, cx, cy) ;
	m_pCBoxSelect->OnSize( nType, cx, cy);
	m_pCRandomSelect->OnSize( nType, cx, cy) ;
	

	//	EChETCYɂāAXN[o[EtH[JXXV
	{
		Ou<CPropStack> pPropStack = createPropStackForScroll() ;

		update() ;
	}

}

void CWndDcdGrid::OnSetFocus(CWnd* pOldWnd) 
{
	//	WCX^XɈϏ
	m_pCFocus->OnSetFocus( pOldWnd ) ;
	m_pCSelect->OnSetFocus( pOldWnd ) ;
	m_pCBoxSelect->OnSetFocus( pOldWnd );
	m_pCRandomSelect->OnSetFocus( pOldWnd ) ;

	super::OnSetFocus(pOldWnd);
}

void CWndDcdGrid::OnKillFocus(CWnd* pNewWnd) 
{
	//(3.1)EChEtH[JXꍇ́A}EXLv`OFF
	//	}EX̃Lv`
	ReleaseCapture() ;

	//	üOhbOXN[v^C}܂B
	if ( m_bOutsideDrag_TimerOn )
	{
		KillTimer( OutsideDrag_TIMERID ) ;
		m_bOutsideDrag_TimerOn = false ;
	}

	//	tH[JXƂɂ́A
	//	{^B
	m_bLButtonIsDown = false ;

	//	WCX^XɈϏ
	m_pCRandomSelect->OnKillFocus( pNewWnd )  ;
	m_pCBoxSelect->OnKillFocus( pNewWnd ) ;
	m_pCSelect->OnKillFocus( pNewWnd ) ;
	m_pCFocus->OnKillFocus( pNewWnd ) ;

	super::OnKillFocus(pNewWnd);
}

void CWndDcdGrid::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//	{^
	m_bLButtonIsDown = true ;
	m_posxyCursorPosOnLButtonDown = CdDcdPosXy( point.x , point.y ) ;

	//(4.1)}EX{^(LButtonDown)
	//@}EX̃Lv`ON
	//	tH[JXړ
	if ( m_bLButtonIsDown )	//   }EX̍{^Ăꍇɐݒ肵܂B
	{
		//	tH[JXZJ[\ʒuɈړ
		CDcdGridCell*	pCell = getCellOfPos( CdDcdPosXy( point.x , point.y ) ) ;
		if ( pCell != NULL )
		{
			//	}EXJ[\́Aǂ̃Z̏ɂ܂B
			//	Obh̊OɃ}EXhbOꂽƂɁA
			//	üOhbOXN[vN܂B

			//@EChẼtH[JXړ
			SetFocus() ;

			//@tH[JXZړ
			{
				Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

				m_pCFocus->setFocusCell( pCell ) ;
			}


			//@}EX̃Lv`ON
			SetCapture() ;

			//	üOhbOXN[ṽ^C}[ON
			SetTimer( OutsideDrag_TIMERID , m_iOutsideDrag_TimeMs , NULL ) ;
			m_bOutsideDrag_TimerOn = true ;
		}
	}

	//	WCX^XɈϏ
	//m_pCFocus->OnLButtonDown(nFlags, point) ;
	//m_pCSelect->OnLButtonDown(nFlags, point) ;
	//m_pCBoxSelect->OnLButtonDown(nFlags, point) ;
	m_pCRandomSelect->OnLButtonDown(nFlags, point)  ;
	
	super::OnLButtonDown(nFlags, point);
}
void CWndDcdGrid::OnLButtonUp(UINT nFlags, CPoint point)
{
	//((4.2)}EX{^(LButtonUp)
	//	}EX̃Lv`
	ReleaseCapture() ;

	//	üOhbOXN[v^C}܂B
	if ( m_bOutsideDrag_TimerOn )
	{
		KillTimer( OutsideDrag_TIMERID ) ;
		m_bOutsideDrag_TimerOn = false ;
	}

	//	{^B
	m_bLButtonIsDown = false ;

	//	WCX^XɈϏ
	//m_pCFocus->OnLButtonUp(nFlags, point) ;
	//m_pCSelect->OnLButtonUp(nFlags, point) ;
	//m_pCBoxSelect->OnLButtonUp(nFlags, point) ;
	m_pCRandomSelect->OnLButtonUp(nFlags, point)  ;

	CWnd::OnLButtonUp(nFlags, point);
}

void CWndDcdGrid::OnMouseMove(UINT nFlags, CPoint point)
{
	//(4.1)}EX{^(LButtonDown)
	//@}EX̃Lv`ON
	//	J[\Gridɂ΁A
	//	tH[JXZJ[\ʒuɈړ
	if ( m_bLButtonIsDown )	//   }EX̍{^Ăꍇɐݒ肵܂B
	{

		//	J[\üOhbOXN[v
		//	KvȈʒuɂ邩ۂ𒲂ׂ܂B
		CdDcdSizeXy	sizeFixafterColumnNumberIncrease = 
			calcIncreaseOnOutsideDrag( point ) ;
		if ( sizeFixafterColumnNumberIncrease.getX() != 0 ||
			sizeFixafterColumnNumberIncrease.getY() != 0 )
		{
			//	üOhbOXN[v
			//	Kvȏꍇ́AtH[JẌړ͍s܂
			//	(OnTimer()ŁAtH[JẌړs܂)
		}
		else
		{
			CRect rectClient ;
			GetClientRect( &rectClient ) ;
			if ( rectClient.left <= point.x && point.x < rectClient.right && 
				rectClient.top <= point.y && point.y < rectClient.bottom )
			{
				//	}EXNCAg̈ȂA
				//	tH[JXZJ[\ʒuɈړ
				CDcdGridCell*	pCell = getCellOfPos( CdDcdPosXy( point.x , point.y ) ) ;
				if ( pCell != NULL )
				{
					//@tH[JXZړ
					{
						//	XN[ʒuXV܂B
						//	AJ[ŹAێ܂
						Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

						m_pCFocus->setFocusCell( pCell ) ;
					}
				}
			}
		}
	}
	//	WCX^XɈϏ
	//m_pCFocus->OnMouseMove(nFlags, point)) ;
	//m_pCSelect->OnMouseMove(nFlags, point) ;
	//m_pCBoxSelect->OnMouseMove(nFlags, point) ;
	m_pCRandomSelect->OnMouseMove(nFlags, point)  ;

	CWnd::OnMouseMove(nFlags, point);
}

void CWndDcdGrid::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CDcdTargetGetDC	aCDcdTarget( GetSafeHwnd() ) ;

	switch( nChar ){
	 case VK_LEFT :	
		{
			CDcdGridCell*	pCell = m_pCDcdGrid->calcMovedCell( 
				m_pCFocus->getFocusCell() , -1 , 0 ) ;
			//@tH[JXZړ
			{
				Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

				m_pCFocus->setFocusCell( pCell ) ;
				
			}
		}
		break ;
	 case VK_RIGHT :	
		{
			CDcdGridCell*	pCell = m_pCDcdGrid->calcMovedCell( 
				m_pCFocus->getFocusCell() , +1 , 0 ) ;
			//@tH[JXZړ
			{
				Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

				m_pCFocus->setFocusCell( pCell ) ;
			}
		}
		break ;
	 case VK_UP :	
		{
			CDcdGridCell*	pCell = m_pCDcdGrid->calcMovedCell( 
				m_pCFocus->getFocusCell() , 0 , -1 ) ;
			//@tH[JXZړ
			{
				Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

				m_pCFocus->setFocusCell( pCell ) ;
			}
		}
		break ;
	 case VK_DOWN :	
		{
			CDcdGridCell*	pCell = m_pCDcdGrid->calcMovedCell( 
				m_pCFocus->getFocusCell() , 0 , +1 ) ;
			//@tH[JXZړ
			{
				Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

				m_pCFocus->setFocusCell( pCell ) ;
			}
		}
		break ;
	 case VK_PRIOR ://PageUp	
		{
			//	VK_SHIFT Ă܂B
			//	Y  PageUPł
			int iFixafterColumnNumber = m_pCDcdGrid->getYFixafterColumnNumber() ;
			int iFixafterColumnNumberNew = m_pCDcdGrid->
				calcYFixafterColumnNumberPagemove( &aCDcdTarget , 
					iFixafterColumnNumber , false ) ;

			//setYFixafterColumnNumber( iFixafterColumnNumberNew ) ;

			//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
			{
				Ou<CPropStack> pPropStack = createPropStackForScroll() ;

				m_pCDcdGrid->setYFixafterColumnNumber( iFixafterColumnNumberNew ) ;
			}
			
		}
		break ;
	 case VK_NEXT :	//PageDown	
		{
			//	Y  PageDownł
			int iFixafterColumnNumber = m_pCDcdGrid->getYFixafterColumnNumber() ;
			int iFixafterColumnNumberNew = m_pCDcdGrid->
				calcYFixafterColumnNumberPagemove( &aCDcdTarget , 
					iFixafterColumnNumber , true ) ;
			//setYFixafterColumnNumber( iFixafterColumnNumberNew ) ;
			
			//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
			{
				Ou<CPropStack> pPropStack = createPropStackForScroll() ;

				m_pCDcdGrid->setYFixafterColumnNumber( iFixafterColumnNumberNew ) ;
			}
		}
		break ;
	 case VK_HOME :
		{
			//	VK_SHIFT Ă܂B
			//	X  PageUPł

			int iFixafterColumnNumber = m_pCDcdGrid->getXFixafterColumnNumber() ;
			int iFixafterColumnNumberNew = m_pCDcdGrid->
				calcXFixafterColumnNumberPagemove( &aCDcdTarget , 
					iFixafterColumnNumber , false ) ;

			//setXFixafterColumnNumber( iFixafterColumnNumberNew ) ;

			//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
			{
				Ou<CPropStack> pPropStack = createPropStackForScroll() ;

				m_pCDcdGrid->setXFixafterColumnNumber( iFixafterColumnNumberNew ) ;
			}
		}
		break ;
	 case VK_END :
		{
			//	VK_SHIFT Ă܂B
			//	X  PageDownł
			int iFixafterColumnNumber = m_pCDcdGrid->getXFixafterColumnNumber() ;
			int iFixafterColumnNumberNew = m_pCDcdGrid->
				calcXFixafterColumnNumberPagemove( &aCDcdTarget , 
					iFixafterColumnNumber , true ) ;
			//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
			{
				Ou<CPropStack> pPropStack = createPropStackForScroll() ;

				m_pCDcdGrid->setXFixafterColumnNumber( iFixafterColumnNumberNew ) ;
			}			
		}
		break ;

	 default:
		{
			//	WCX^XɈϏ
			//m_pCFocus->OnKeyDown(nChar, nRepCnt, nFlags) ;
			//m_pCSelect->OnKeyDown(nChar, nRepCnt, nFlags);
			//m_pCBoxSelect->OnKeyDown(nChar, nRepCnt, nFlags) ;
			m_pCRandomSelect->OnKeyDown(nChar, nRepCnt, nFlags) ;

			super::OnKeyDown(nChar, nRepCnt, nFlags);
		}
	}

	
}

int CWndDcdGrid::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	return 0;
}

void CWndDcdGrid::OnDestroy() 
{
	CWnd::OnDestroy();
}


BOOL CWndDcdGrid::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	if ( nFlags == 0 )
	{
		int iYMove = zDelta / (-WHEEL_DELTA) ;
		//iYMove = YɈړ鐔B

		//	XN[̕ύX(PageUp,PageDown,Home,EndL[܂)
		{
			//	XN[ʒuɍ킹ătH[JXʒuXV܂B
			//	AJ[ŹAShiftĂێ܂B
			//	ShiftĂȂꍇ͍XV܂B
			Ou<CPropStack> pPropStack = createPropStackForScroll() ;

			m_pCDcdGrid->setYFixafterColumnNumber( m_pCDcdGrid->getYFixafterColumnNumber() + iYMove ) ;
		}

		return ( TRUE ) ;
	}	
	return super::OnMouseWheel(nFlags, zDelta, pt);
}



void CWndDcdGrid::OnTimer(UINT_PTR nIDEvent)
{
	//	üOhbOXN[v
	if ( nIDEvent == OutsideDrag_TIMERID )
	{
		CPoint	point ;
		GetCursorPos( &point ) ;
		ScreenToClient( &point ) ;

		//	J[\üOhbOXN[v
		//	KvȈʒuɂ邩ۂ𒲂ׂ܂B
		CdDcdSizeXy	sizeFixafterColumnNumberIncrease = 
			calcIncreaseOnOutsideDrag( point ) ;
		if ( sizeFixafterColumnNumberIncrease.getX() != 0 ||
			sizeFixafterColumnNumberIncrease.getY() != 0 )
		{
			//	üOhbOXN[v
			//	Kvȏꍇ́AXN[s܂B

			// --------------------------------
			//	tH[JXZړ@
			// --------------------------------
			//memo:
			//	^C}FixafterColumnNumberω@ł́A
			//	tH[JXZǏ]Ȃ߁A
			//	sRȓɂȂ܂B
			//	̂߁A^C}ŃtH[JXZ
			//	ړ邱Ƃɂ܂B
			CDcdGridCell*	pCell = m_pCFocus->getFocusCell() ;
			if ( pCell != NULL )
			{
				pCell = m_pCDcdGrid->calcMovedCell( pCell , 
					sizeFixafterColumnNumberIncrease.getX() , 
					sizeFixafterColumnNumberIncrease.getY() ) ; 

				//	tH[JXZ̈ړ
				{
					//	XN[ʒuXV܂B
					//	AJ[ŹAێ܂(̃^C}Lȏꍇ
					//	hbÔ)B
					Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

					m_pCFocus->setFocusCell( pCell ) ;
				}
			}
		}
	}
	else
	{
		CWnd::OnTimer(nIDEvent);
	}
}
void CWndDcdGrid::OnRButtonDown(UINT nFlags, CPoint point)
{

	//	E@tH[JXZȊÕZENbNꍇ́A
	//	tH[JXZNbNꂽZɈړB
	//	̂ƂAZ̕I͉B̌AReLXgj[\
	//	E@tH[JXZENbNꍇE̓ZȊȌꏊ
	//	ENbNꍇ́AZ̕IێB̌AReLXgj[\
	//yRz
	//	Z𕡐IԂŁAtH[JXZȊÕZENbNƁA
	//	ZIꂽ܂܁AReLXgj[\Ă܂܂B
	//	́AMicrosoft Excel Ȃǂ̈ʓIȃ\tgEGAƂ͓삪قȂAsւɊ܂B

	//	E{^ꂽƂ́ÃEChEɖI
	//	tH[JXݒ肷Kv܂B
	//
	//yRz
	//	̃EChEJ́ÃEChE
	//	tH[JXĂ܂B
	//	܂AEChE͉E{^ł́A
	//	tH[JX𓾂܂B
	//	̂߁ACWndDcdGrid2::CFocus::m_bIsFocusmarkShowEvery 
	//	falsȅꍇ́AZENbNłÃZɃtH[JX}[N`悳܂B
	SetFocus() ;

	{
		//	}EXNCAg̈ŁAtH[JXZȊÕZɂȂA
		//	tH[JXZJ[\ʒuɈړ
		CRect rectClient ;
		GetClientRect( &rectClient ) ;
		if ( rectClient.left <= point.x && point.x < rectClient.right && 
			rectClient.top <= point.y && point.y < rectClient.bottom )
		{
			CDcdGridCell*	pCell = getCellOfPos( CdDcdPosXy( point.x , point.y ) ) ;
			CDcdGridCell*	pCellFocus = getCFocus()->getFocusCell() ;
			if ( pCell != NULL && pCell != pCellFocus )
			{
				//	`œK
				Ou<CPropStack> pPropStack = createPropStackForMovingFocusCell() ;

				//tH[JXZJ[\ʒuɈړ
				m_pCFocus->setFocusCell( pCell ) ;
				

				//Z̑I
				m_pCBoxSelect->clearSelect() ;
				m_pCSelect->clearSelect() ;
			}
		}
	}
	CWnd::OnRButtonDown(nFlags, point);
}

} //namespace WndDcdGrid3
} //namespace DcdGrid
} //namespace DcDrawLib

